// Program pro ovldn budi motor malho kolnho robotu
// Verze: 2
// Datum: 14.5.2007

#include <avr/io.h>						
#include <avr/delay.h>					
#include <avr/interrupt.h>			    

// sla bit signl vedench do obvodu L297  
#define ENABLE 1  
#define CLOCK 3
#define CONTROL 4
#define DIR_CW 5
#define HALF 6
#define NO_RESET 7

#define MinCommandsPerInterval 6;     // Minimln poet pijatch povel bez zastaven systmu

unsigned int BaudRate = 9600;         // Implicitn penosov rychlost rozhrann USART
int i, j;
char x = 0;
int Command = 0;
int CommandDataIndex = 0;
char receive = 0;
int MotorIndex = 0;
int T1, T2 = 0;
int Period = 0;
int MotorsEnable = 1;                 // 1=povolen, 0=zablokovn obou motor 
unsigned int Value, Value2 = 0;
unsigned int CommandsPerInterval = 0; // Poet pijatch pkaz bhem intervalu pro automatick zastaven

// Motor 1
char Motor1Clk = 0;                   // Hodiny motoru peklpjc se asovaem
int Motor1Speed = 32000;              // Perioda asovae
unsigned int Motor1SpeedU = 0;        // Perioda asovae bez znamennka
unsigned char Motor1SpeedLow = 0;     // Doln polovina pijat periody
unsigned char Motor1SpeedHigh = 0;    // Horn polovina pijat periody
char Motor1Direction = 0;             // Smr motoru 
char Motor1Enabled = 0;               // Povolen motoru
char Motor1HalfStep = 0;              // Polovin krok
char Motor1ControlOutput = 1;         // zen vstupnch linek

// Motor 2
char Motor2Clk = 0;                   // Hodiny motoru peklpjc se asovaem
int Motor2Speed = 32000;              // Perioda asovae
unsigned int Motor2SpeedU = 0;        // Perioda asovae bez znamennka
unsigned char Motor2SpeedLow = 0;     // Doln polovina pijat periody
unsigned char Motor2SpeedHigh = 0;    // Horn polovina pijat periody
char Motor2Direction = 0;             // Smr motoru 
char Motor2Enabled = 0;               // Povolen motoru
char Motor2HalfStep = 0;              // Polovin krok
char Motor2ControlOutput = 1;         // zen vstupnch linek

// Inicializace sriov linky 
void USARTInit(void)
{
  cli();                              // Zakzn peruen
  unsigned int BRR = (F_CPU / 16 / BaudRate) - 1;
  UBRRH = (unsigned char) (BRR >> 8);
  UBRRL = (unsigned char) BRR;
  UCSRB = (1 << RXEN) | (1 << TXEN) | (1<<RXCIE);
  UCSRC = (1 << URSEL) | (3 << UCSZ0);
  sei();                              // Povolen peruen
}

// Obsluha peruen od sriov linky
SIGNAL(SIG_UART_RECV)
{
  if(CommandDataIndex == 0) 
  {
	  Command = UDR;
	  CommandsPerInterval++;			// ta pijatch povel bhem intervalu
  } 
	switch(Command)
	{
	  case 0: 
	    CommandDataIndex = 0;
		break;
	  case 1:   // Motor 1 speed
		  switch(CommandDataIndex)
		  {
		    case 0:
			  CommandDataIndex = CommandDataIndex + 1;  
			  break;
            case 1:
			  Motor1SpeedLow = UDR;
              CommandDataIndex = CommandDataIndex + 1;  
		      break;
            case 2:
  		      Motor1SpeedHigh = UDR;
		      Motor1Speed = Motor1SpeedLow | (Motor1SpeedHigh << 8);
              if(Motor1Speed > 0) Motor1Direction = 1; else Motor1Direction = 0;
 			
	  		  if(Motor1Speed < 0) Motor1SpeedU = -Motor1Speed; 
			  else Motor1SpeedU = Motor1Speed;
			  //SpeedU = SpeedU;
			  if(Motor1SpeedU == 0) Motor1SpeedU = 1;
			  if(Motor1SpeedU == 32767) Motor1SpeedU = 32766;
			
 	          CommandDataIndex = 0;
			  break;
          }
		  break;
	    case 2:   // Motor 1 enabled
		  switch(CommandDataIndex)
		  {
		    case 0:
			  CommandDataIndex = CommandDataIndex + 1;  
			  break;
		    case 1:		
  		      Motor1Enabled = UDR & 1;			  
			  CommandDataIndex = 0;  
			  break;
          }
		  break;
	    case 3:   // Motor 1 half step
		  switch(CommandDataIndex)
		  {
		    case 0:
			  CommandDataIndex = CommandDataIndex + 1;  
			  break;
		    case 1:		
  		      Motor1HalfStep = UDR & 1;			  
			  CommandDataIndex = 0;  
			  break;
          }
		  break;
	    case 4:   // Set USART baud rate
		  switch(CommandDataIndex)
		  {
		    case 0:
			  CommandDataIndex = CommandDataIndex + 1;  
			  break;
		    case 1:
  		      BaudRate = UDR;			  
			  CommandDataIndex = CommandDataIndex + 1;  
			  break;
		    case 2:		
  		      BaudRate = (BaudRate & 0xff) | (UDR << 8);			  
              USARTInit();

			  CommandDataIndex = 0;  
			  break;
          }
		  break;
	    case 5:   // Motor 1 control output lines
		  switch(CommandDataIndex)
		  {
		    case 0:
			  CommandDataIndex = CommandDataIndex + 1;  
			  break;
		    case 1:		
  		      Motor1ControlOutput = UDR & 1;			  
			  CommandDataIndex = 0;  
			  break;
          }
		  break;
	    case 6:   // Motor 2 speed
		  switch(CommandDataIndex)
		  {
		    case 0:
			  CommandDataIndex = CommandDataIndex + 1;  
			  break;
            case 1:
			  Motor2SpeedLow = UDR;
              CommandDataIndex = CommandDataIndex + 1;  
		      break;
            case 2:
  		      Motor2SpeedHigh = UDR;
		      Motor2Speed = Motor2SpeedLow | (Motor2SpeedHigh << 8);
              if(Motor2Speed > 0) Motor2Direction = 1; else Motor2Direction = 0;
              //if(Speed == 0) Enabled = 0; else 
 			
	  		  if(Motor2Speed < 0) Motor2SpeedU = -Motor2Speed; 
			  else Motor2SpeedU = Motor2Speed;
			  //SpeedU = SpeedU;
			  if(Motor2SpeedU == 0)  Motor2SpeedU = 1;
			  if(Motor2SpeedU == 32767)  Motor2SpeedU = 32766;
			
 	          CommandDataIndex = 0;
			  break;
          }
		  break;
	    case 7:   // Motor 2 enabled
		  switch(CommandDataIndex)
		  {
		    case 0:
			  CommandDataIndex = CommandDataIndex + 1;  
			  break;
		    case 1:		
  		      Motor2Enabled = UDR & 1;			  
			  CommandDataIndex = 0;  
			  break;
          }
		  break;
	    case 8:   // Motor 2 half step
		  switch(CommandDataIndex)
		  {
		    case 0:
			  CommandDataIndex = CommandDataIndex + 1;  
			  break;
		    case 1:		
  		      Motor2HalfStep = UDR & 1;			  
			  CommandDataIndex = 0;  
			  break;
          }
		  break;
	    case 9:   // Motor 2 control output lines
		  switch(CommandDataIndex)
		  {
		    case 0:
			  CommandDataIndex = CommandDataIndex + 1;  
			  break;
		    case 1:		
  		      Motor2ControlOutput = UDR & 1;			  
			  CommandDataIndex = 0;  
			  break;
          }
		  break;
        case 10:   // Motors enable
		  switch(CommandDataIndex)
		  {
		    case 0:
			  CommandDataIndex = CommandDataIndex + 1;  
			  break;
		    case 1:		
  		      MotorsEnable = UDR & 1;			  
			  CommandDataIndex = 0;  
			  break;
          }
		  break;
		default:
		  CommandDataIndex = 0;
		  break;
	  }
    }

}

// Inicializace asovae
void TimerInit(void)
{
  cli();					// Zakzn peruen
  // Timer 1 - stepper motors control
  TCCR1A = 0;											// WGM13..10=0 - normal counter
  TCCR1B = (0 << WGM12) | (1 << CS11) | (1 << CS10);    // CS12..10=3 - prescaler clk/64
  OCR1A = 1; 
  OCR1B = 1;   
  TIMSK = (1 << OCIE1A) | (1 << OCIE1B) | (1 << TOV1);  // Spoutc maska pro OCA, OCB a TOV
  sei();					// Povolen peruen
}

// Obsluha asovae - prvn motor 
ISR(TIMER1_COMPA_vect)
{
  if((Motor1Speed != 0) && (MotorsEnable)) Motor1Clk = 1 - Motor1Clk;
  PORTA = (Motor1HalfStep << HALF) | (1 << NO_RESET) | (Motor1ControlOutput << CONTROL) | (Motor1Clk << CLOCK) 
    | (Motor1Enabled << ENABLE) | (Motor1Direction << DIR_CW);
  OCR1A = OCR1A + Motor1SpeedU;
}

// Obsluha asovae - druh motor 
ISR(TIMER1_COMPB_vect)
{ 
  if((Motor2Speed != 0) && (MotorsEnable)) Motor2Clk = 1 - Motor2Clk;
  PORTB = (Motor2HalfStep << HALF) | (1 << NO_RESET) | (Motor2ControlOutput << CONTROL) | (Motor2Clk << CLOCK) 
    | (Motor2Enabled << ENABLE) | (Motor2Direction << DIR_CW);
  OCR1B = OCR1B + Motor2SpeedU;
}

// Obsluha asovae - automatick bezpenostn zastaven
ISR(TIMER1_OVF_vect)
{
  if(CommandsPerInterval < MinCommandsPerInterval) 
  {
    Motor1Speed = 0;
	Motor2Speed = 0;
  }
  CommandsPerInterval = 0;			// Nulovn tae pro nov interval
}

int main(void)
{
  DDRA = 0xfa;						// Nastaven vstupnch bit portu motoru
  DDRB = 0xfa;						// NAstaven vstupnch bit portu motoru

  TimerInit();
  USARTInit();
  while(1);							// Nekonen smyka
}

